from django.shortcuts import get_object_or_404, render

# Create your views here.
from django.db import IntegrityError
from django.utils import timezone
from django.http import HttpResponse
from django.template import loader
from django.contrib.auth import login,logout
from .models import Sifrovacka, Stages, Participants


def stage(request, sifrovacka_id, stage_urlhash):
#    print(dir(request.user.participants_set.values))
#    print(stage_urlhash)
#    print(request.user.participants_set.values())
#    sifrovacka_current_stage = request.user.participants_set.values_list('id')
    sifrovacka_current = None
    sifrovacka_detail = Sifrovacka.objects.get(id = sifrovacka_id)
    sifrovacka_stages = Stages.objects.filter(sifrovacka__sifrovacka_name = sifrovacka_detail)
    sifrovacka_stage_count = sifrovacka_stages.count()
    if request.user.is_authenticated:
#        sifrovacka_current = Participants.objects.filter(user = \
#                              request.user).filter(sifrovacka_id =
#                              sifrovacka_id)
        sifrovacka_all_user_current_stages= Participants.objects.filter(user = \
                                             request.user).filter(sifrovacka_id = \
                                             sifrovacka_id).values('sifrovacka_id','id')
        for s in sifrovacka_all_user_current_stages:
            if s['sifrovacka_id'] == sifrovacka_id:
                print("---AA---")
    #            print(s['at_stage'])
                tmp_stage_id = s['id']
                sifrovacka_current_stage_urlhash = Participants.objects.get(id = \
                                                    tmp_stage_id)
                if (sifrovacka_current_stage_urlhash.at_stage == stage_urlhash):
                    print('hehe')
                    sifrovacka_current = Participants.objects.get(id = \
                                          tmp_stage_id)
                else:
                    print('not same')
#    else:
#        sifrovacka_current = None

    print(sifrovacka_current)
    context = {"sifrovacka_id": sifrovacka_id,
               "sifrovacka_detail": sifrovacka_detail,
               "sifrovacka_stages": sifrovacka_stages,
               "sifrovacka_stage_count": sifrovacka_stage_count,
               "sifrovacka_current": sifrovacka_current
              }
    return render(request, 'stage.html', context)

def detail(request, sifrovacka_id):
    print(request)
    sifrovacka_detail = Sifrovacka.objects.get(id = sifrovacka_id)
    sifrovacka_stages = Stages.objects.filter(sifrovacka__sifrovacka_name = sifrovacka_detail)
    sifrovacka_stage_count = sifrovacka_stages.count()
    context = {"sifrovacka_id": sifrovacka_id,
               "sifrovacka_detail": sifrovacka_detail,
               "sifrovacka_stages": sifrovacka_stages,
               "sifrovacka_stage_count": sifrovacka_stage_count}
    return render(request, 'sifrovacka.html', context)

def home(request):
    all_sifrovacky_list = Sifrovacka.objects.order_by('id')
    # only for auth users
    if request.user.is_authenticated:
        participation_sifrovacky_list = Participants.objects.filter(user =
                                        request.user).order_by('sifrovacka_id')
        if request.method == 'POST':
              if request.POST["signupsif"]:
                  post_signupsif = request.POST["signupsif"]
                  print(post_signupsif)
                  try:
                      p = Participants.objects.create(user=request.user,
                              sifrovacka_id=post_signupsif)
                  except IntegrityError as e:
                      print(e)
                      context = {"active_sifrovacky_list": all_sifrovacky_list,
                                  "participation_sifrovacky_list": participation_sifrovacky_list,
                                  "error_alreadysigned": e
                                }
                      return render(request, 'home.html', context)
                  else:
                      p.save()
    else:
        participation_sifrovacky_list = None

   #    import pdb
   #    pdb.set_trace()
       # sifrovacka_name = Sifrovacka.objects.get(id = sifrovacka_id)
    context = {"active_sifrovacky_list": all_sifrovacky_list,
                   "participation_sifrovacky_list": participation_sifrovacky_list}

    return render(request, 'home.html', context)

def index(request):
    if request.user.is_authenticated:
        list_user_active_sifrovacky = Participants.objects.filter( user =
                                      request.user).order_by('sifrovacka_id')
        #list_user_active_sifrovacky = request.user.participants_set.values_list(
        #                            'sifrovacka_id')
        list_all_user_sifrovacky = request.user.participants_set.values_list(
                                    'sifrovacka_id', flat=True)
        print(list_user_active_sifrovacky)
        list_available = Sifrovacka.objects.filter(
                          startdate_sifrovacka__lte = timezone.now()).filter(
                          enddate_sifrovacka__gte = timezone.now()).exclude(
                          id__in=list_all_user_sifrovacky)
        #print(list_available)
        list_all_sifrovacky = list_available


    else:
        list_all_sifrovacky = Sifrovacka.objects.filter(
                               startdate_sifrovacka__lte = timezone.now()).filter(
                               enddate_sifrovacka__gte = timezone.now())
        list_user_active_sifrovacky = []

    list_archived_sifrovacky = Sifrovacka.objects.filter(
                               startdate_sifrovacka__lte = timezone.now()).filter(
                               enddate_sifrovacka__lt = timezone.now())



    context = {"sifrovacky_list": list_all_sifrovacky,
               "archived_sifrovacky": list_archived_sifrovacky,
               "user_active_sifrovacky": list_user_active_sifrovacky,
              }
    #context = {"": ""}

    return render(request, 'index.html', context)





